/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZTextWindow.h		-- a window that displays text files (uses TextEdit)
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once

#ifndef __ZTEXTWINDOW__
#define	__ZTEXTWINDOW__


#include	"ZScroller.h"
#include	<TextEdit.h>
/*

This is a scroller that displays text. It does this by using TextEdit. You can edit the text
if editable is true, and save a text file of the contents. It cannot open very big files
because of the TextEdit limitations.

*/

class	ZTextWindow	: public ZScroller
{
protected:
	TEHandle	itsText;
	Boolean		isEditable;
	short		emSpace;

public:
	ZTextWindow(ZCommander* aBoss, short windID, Boolean allowEditing);
	~ZTextWindow();
	
	virtual void	InitZWindow();
	virtual void	DrawContent();
	virtual void	ClickContent(Point mouse, short modifiers);
	virtual void	Activate();
	virtual void	Deactivate();
	virtual void	SetSize(short width, short height);
	virtual void	Zoom(short partCode);
	virtual void	Scroll(short dH, short dV);
	virtual void	Type(char theChar);
	virtual void	OpenFile(OSType fType);
	virtual void	SaveFile();
	virtual void	Idle();
	virtual void	GetContentRect(Rect* contents);
	virtual void	AdjustCursor( const Point mouse, const short modifiers );
	
	virtual void	UpdateMenus();
	virtual Boolean	CanPasteType();
	virtual void	DoCut();
	virtual void	DoCopy();
	virtual void	DoPaste();
	virtual void	DoClear();
	virtual void	DoSelectAll();
	
	inline	TEHandle	GetTextHandle() { return itsText; };
	
protected:

	virtual void	MakeTextEdit();
	virtual void	RecalText();
};



#define		kTextFileTooBigErr		77
#define		kMaxTextSize			20000

#endif