/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZPaintWindow.h 		-- a window you can paint in with the paint engine
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once


#ifndef _ZPAINTWINDOW__
#define _ZPAINTWINDOW__



#include	"ZGWorldWindow.h"


class ZPaintEngine;


// class definition

class ZPaintWindow	: public ZGWorldWindow
{
protected:
	RgnHandle		itsSelection;
	Boolean			rulersVisible;
	
public:

	ZPaintWindow( ZCommander* aBoss, short windID );
	~ZPaintWindow();

	virtual void	InitZWindow();

	virtual void	ClickContent( const Point mouse, const short modifiers );
	virtual void	Draw();
	virtual void	DrawContent();
	virtual void	GetContentRect( Rect* aRect );
	virtual void	HandleCommand( const long aCmd );
	virtual void	UpdateMenus();
	virtual void	AdjustCursor( const Point mouse, const short modifiers);
	virtual void	Type( const char theKey );
	virtual void	Idle();
	virtual void	DoCut();
	virtual void	DoCopy();
	virtual void	DoPaste();
	virtual void	DoClear();
	virtual void	DoSelectAll();
	virtual void	Activate();
	virtual void	Deactivate();
	virtual void	Revert();
	virtual Boolean	Close( const short phase );
	virtual void	ReportMouseLoc( Point anchor, Point loc, Boolean inDrag );
	virtual void	ReceiveMessage( ZComrade* aSender, long aMsg, void* msgData );
	virtual void	OpenFile( const OSType fType );
		
protected:
	virtual void	MakeGWorld();
	virtual void	MakeNewGWorld( const short aWidth, const short aHeight, const short aDepth = 0 );
	virtual void	MoveScrollbars();
	
	virtual void	DrawImageInfo();
	
	void			SetupWindowFromGWorld();
	void			DoDialog( const short dialogID );
	
	virtual void	SwitchDepth( const short aDepth );
};


#define		kFirstToolCmd			1000

// cursor resource ID's

#define		kColourPickerCursorID	1021
#define		kRectSelectionCursorID	1023
#define		kLassoSelectCursorID	1024
#define		kMagicWandCursorID		1025
#define		kAltArrowCURSID			1026
#define		kRectPlusCursorID		1027
#define		kLassoPlusCursorID		1028
#define		kMagicWandPlusCursorID	1029
#define		kRectMinusCursorID		1031
#define		kLassoMinusCursorID		1032
#define		kMagicWandMinusCursorID	1033
#define		kZoomPlusCursorID		1034
#define		kZoomMinusCursorID		1035
#define		kAltStampCursorID		1036

#define		kDefaultWidth			512
#define		kDefaultHeight			384

#define		kGradientDialogID		302
#define		kBitMapDialogID			303
#define		kPatternsDialogID		304
#define		kRulersDialogID			305
#define		kStampsDialogID			306
#define		kFilterDialogID			307

#define		kInfoWidth				120
#define		kAltMenuStringsID		203

#define		kRulerWidth				16

// messages

#define		kPaintWindowBecomeActive	'pwac'
#define		kPaintWindowMouseInfo		'pwmi'
#define		kPaintWindowImageLoaded		'pwil'
#define		kPaintWindowDepthChanged	'pwdx'

// commands handled by this class:

enum
{
	kCmdFlipHorizontal 			= 140,
	kCmdFlipVertical 			= 141,
	kCmdEditGradients 			= 302,
	kCmdEditPatterns  			= 304,
	kCmdEditRulers   			= 305,
	kCmdEditStamps				= 306,
	kCmdEditFilter				= 307,
	kCmdFatbitsGrid	  			= 401,
	kCmdFillSelection 			= 411,
	kCmdActivateMask  			= 250,
	kCmdDeactivateMask 			= 251,
	kCmdAddToMask	  			= 252,
	kCmdSubFromMask	  			= 253,
	kCmdClearMask	  			= 254,
	kCmdShowHideMask  			= 255,
	kCmdInvertMask	  			= 256,
	kCmdSetMask		  			= 257,
	kCmdSwitchToBlackAndWhite 	= 221,
	kCmdSwitchTo16Greys 		= 222,
	kCmdSwitchTo16Colours 		= 223,
	kCmdSwitchTo256Greys 		= 224,
	kCmdSwitchTo256Colours 		= 225,
	kCmdSwitchToThousands 		= 226,
	kCmdSwitchToMillions 		= 227,
	kCmdShowHideRulers			= 410,
	kCmdSet100PercentZoom		= 228
};


extern	ZPaintEngine*	gPaintEngine;

#endif