/*************************************************************************************************
*
*
*			ObjectMacZapp			-- a standard Mac OOP application template
*
*
*
*			ZUndoPaintTask.cpp		-- undo task for handling paint operations from ZPaintEngine
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/

#include	"ZUndoPaintTask.h"
#include	"ZGWorld.h"
#include	"ZGWorldWindow.h"
#include	"MacZoop.h"


ZUndoPaintTask::ZUndoPaintTask( Str63 aTaskString, ZWindow*	aTarget )
	: ZUndoTask( aTaskString, aTarget )
{
	uBuffer = NULL;
	
	RecordImage();
}


ZUndoPaintTask::~ZUndoPaintTask()
{
	if ( uBuffer )
		ForgetObject( uBuffer );
}


void	ZUndoPaintTask::Do()
{
	inherited::Do();
	SwitchImageBuffers();
}


void	ZUndoPaintTask::Undo()
{
	inherited::Undo();
	SwitchImageBuffers();
}


void	ZUndoPaintTask::SwitchImageBuffers()
{
	ZGWorldWindow*	zgw = dynamic_cast<ZGWorldWindow*>( itsTarget );
	
	if ( zgw )
	{
		ZGWorld*	temp;
		
		temp = uBuffer;
		uBuffer = zgw->GetGWorld();
		
		zgw->SetGWorld( temp );
	
		itsTarget->PostRefresh();
	}
}



void	ZUndoPaintTask::RecordImage()
{
	ZGWorldWindow*	zgw = dynamic_cast<ZGWorldWindow*>( itsTarget );
	
	if ( zgw )
		FailNIL( uBuffer = new ZGWorld( zgw->GetGWorld()));

}
